import jss from "jss";
import preset from "jss-preset-default";
let sheets = {};
let defaultKey = {};
jss.setup(Object.assign({}, preset()));
function getStyles({ theme = defaultKey, styles, componentName, useAdoptedStyles }) {
    if (!sheets[componentName]) {
        sheets[componentName] = new WeakMap();
    }
    if (!sheets[componentName].has(theme)) {
        let componentStyles = Object.assign({}, styles);
        if (theme[componentName]) {
            for (const property in theme[componentName]) {
                componentStyles[property] = Object.assign(Object.assign({}, componentStyles[property]), theme[componentName][property]);
            }
        }
        const sheet = jss.createStyleSheet(componentStyles);
        sheet.update(theme);
        sheets[componentName].set(theme, getStyleObject(sheet, useAdoptedStyles));
    }
    return sheets[componentName].get(theme);
}
function getStyleObject(sheet, useAdoptedStyles) {
    let adoptedSheet = null;
    if (useAdoptedStyles) {
        adoptedSheet = new CSSStyleSheet();
        adoptedSheet.replaceSync(sheet.toString());
        Object.defineProperty(adoptedSheet, "data-cssInJsId", {
            value: "cssInJsId"
        });
    }
    return {
        sheet,
        adoptedSheet
    };
}
export { getStyles };
